
// Sprocket 0.4.1
// Copyright (c) 1998	Sprocket Development Team
// header file from ftpw.cpp
//


#ifndef FTP_H
#define FTP_H
#include <stdio.h>
#include <qdatetm.h>
#include <qpixmap.h>
#include <qpushbt.h>
#include <qfont.h>
#include <qdialog.h>
#include <qpopmenu.h>
#include <qkeycode.h>
#include <qapp.h>
#include <qmsgbox.h>
#include <qlabel.h>
#include <qmlined.h>
#include <qcolor.h>
#include <qgrpbox.h>
#include <qlayout.h>
#include <qlistbox.h>
#include <qtooltip.h>
#include <qlined.h>
#include <qdir.h>
#include <qwidget.h>
#include <qmenubar.h>
#include <qtabdlg.h>
#include <qcombo.h>
#include <qchkbox.h>
#include <qmlined.h>
#include <qfile.h>
#include <qtstream.h>
#include <qevent.h>
#include <qmovie.h>
#include <qpainter.h>

#ifndef NO_LOC_DIR
extern int cnw_flag;
extern char timestring[1024];
extern const char *loc_dir;
extern const char *loc_file;
extern char rem_dir[1024];
extern char rem_file[1024];
extern char ftp_host[1024];
extern char loginnaam[1024];
extern char wachtwoord[1024];
#endif

#define MOVIEFILENAME "stripper.gif"

//---[ FtpWidget ]-----------------------------------------------------------


class FtpWidget : public QWidget
{
    Q_OBJECT
public:
   FtpWidget( QWidget *parent=0, const char *name=0 );
   QLineEdit *local_dir_ed;			// Local EditBox
   QLineEdit *remote_dir_ed;			// Remote EditBox
   QListBox  *local_dir_box;   			// Local Directory ListBox
   QListBox  *local_file_box;			// Local File ListBox
   QListBox  *remote_dir_box;			// Remote Directory ListBox
   QListBox  *remote_file_box;			// Remote File ListBox
   QListBox  *ftpmsg;
   QDir	     *xyz;				// QDir naar huidige dir.
   QLabel    *msglabel;   			// MessageLabel	 					

   QPushButton *style_btn;
   QPushButton *exit_btn;
   QPushButton *about_btn;
   QPushButton *local_refresh_btn;
   QPushButton *local_mkdir_btn;
   QPushButton *local_rmdir_btn;
   QPushButton *local_mvdir_btn;
   QPushButton *local_view_btn;
   QPushButton *local_delete_btn;
   QPushButton *local_rename_btn;
   QPushButton *rem_mkdir_btn;
   QPushButton *rem_rmdir_btn;
   QPushButton *upload_btn;
   QPushButton *download_btn;
   QPushButton *rem_refresh_btn;
   QPushButton *rem_view_btn;
   QPushButton *rem_delete_btn;
   QPushButton *connect_btn;
   QPushButton *disconnect_btn;
   QGroupBox *remotegroup;
   QGroupBox *localgroup;
public slots:

// local
  void loc_view_file();
  void loc_delete_file();
  void loc_rename_file();
  void loc_ret_pressed();
  void loc_mkdir();
  void warning_dir();
  void loc_rmdir();
  void loc_mvdir();
  void change_local_dir(int index);
  void active_dirs();
  void active_files();
  void refresh_local();

// remote
  void rem_mkdir();
  void rem_rmdir();
  void rem_refresh();
  void rem_view_file();
  void rem_delete_file();
  void remote_ret_pressed();
  void change_remote_dir();
  void rem_active_dirs();
  void rem_active_files();

// misc
  void upload();
  void download();
  void sorry();

// lowest buttons
  void disconnect();
  void about();
  void connect_to();
  void ch_style();

// put the selected items in a global variable
  void put_loc_dir(int index);
  void put_loc_file(int index);
  void put_rem_dir(int index);
  void put_rem_file(int index);
// the resizeevent
  void resizeEvent(QResizeEvent *);
protected:
  void styleChange( GUIStyle );

signals:
  void explain( const char * );
  void refresh_rem();


private:

};




//---[ Make local directory ]-------------------------------------------

class MkdirWidget : public QDialog
{
    Q_OBJECT
public:
    MkdirWidget( QWidget *parent=0, const char *name=0);
    QLineEdit *mkdir_ed;    			// Makedir Edit Box


public slots:
   void exit_mkdir_loc();
   void mkdir_ok();

protected:

signals:
  void warning();
  void refresh_dir();
private:

};




//---[ Delete local dir ]------------------------------------------------

class RmdirWidget : public QDialog
{
    Q_OBJECT
public:
    RmdirWidget( QWidget *parent=0, const char *name=0);

public slots:
   void exit_rmdir_loc();
   void rmdir_yes(); //(int index);
   void rmdir_cancel();
protected:

signals:
   void warning();
   void refresh_dir();
private:

};




//---[ View local file ]-------------------------------------------

class ViewWidget : public QDialog
{
    Q_OBJECT
public:
    ViewWidget( QWidget *parent=0, const char *name=0);
    QMultiLineEdit *view_edit;
    QPushButton *ok_btn;


public slots:
	void exit_view();
	void read_file();
   void resizeEvent(QResizeEvent *);


protected:

signals:

private:

};

//---[ Rename local directory ]------------------------------------

class RenamelocdirWidget : public QDialog
{
	Q_OBJECT
public:
	RenamelocdirWidget( QWidget *parent=0, const char *name=0);
	QLineEdit *renamelocdir_ed;			// Edit Box
	
public slots:		
	void exit_renamelocdir();
	void renamelocdir_ok();

protected:

signals:
	void warning();
	void refresh_dir();
		
private:

};
	



//---[ Rename local file ]--------------------------------------------------

class RenamelocWidget : public QDialog
{
	Q_OBJECT
public:
	RenamelocWidget( QWidget *parent=0, const char *name=0);
	QLineEdit *renameloc_ed;			// Renameloc Edit Box

public slots:
	void exit_renameloc();
	void renameloc_ok();
	
protected:

signals:
	void warning();
	void refresh_dir();

private:

};

//*********************************************************************
//***[ REMOTE ]********************************************************
//*********************************************************************

//---[ Make remote directory ]-----------------------------------------

class RemMkdirWidget : public QDialog
{
   Q_OBJECT
public:
   RemMkdirWidget( QWidget *parent=0, const char *name=0);
   QLineEdit *rem_mkdir_ed;		// Edit Box

public slots:
   void rem_mkdir_ok();
   void exit_mkdir_rem();

protected:

signals:
   void warning();
   void refresh_rem();

private:

};

//---[ View local file ]-------------------------------------------

class RemViewWidget : public QDialog
{
    Q_OBJECT
public:
    RemViewWidget( QWidget *parent=0, const char *name=0);
    QMultiLineEdit *view_edit;
    QPushButton *ok_btn;


public slots:
        void exit_view();
        void read_file();
        void resizeEvent(QResizeEvent *);


protected:

signals:

private:

};



//---[ Connect Widget ]-------------------------------------------------

class ConnectWidget : public QDialog
{
    Q_OBJECT

public:
    ConnectWidget( QWidget *parent=0, const char *name=0);
    QLabel *profile_name;
    QLabel *h_name;
    QLabel *u_id;
    QLabel *p_wd;
    QLineEdit *host_name;
    QLineEdit *user_id;
    QLineEdit *pass_wd;
    QCheckBox *anon;

    char host[30], login_name[20], passwd[20];

public slots:
    void ok_connect();
    void anonymous_ftp();
    void cancel();

protected:

signals:
   void refresh_rem();	

private:

};


//---[ About Widget ]----------------------------------------------

class AboutWidget : public QDialog
{
   Q_OBJECT
public:
   AboutWidget( QWidget *parent=0, const char *name=0);
   QMovie movie;
   QLabel *movielabel;
   QPushButton *ok_btn;
public slots:
    void exit_about();

protected:

signals:

private:

};


////////////////////////////////////////////////////////////////////

#endif  FTP_H

