/***************************************************************************/
/*									   */
/* Sprocket 0.4.3 - Graphical FTP-client for X-Windows			   */
/* Copyright (C) 1998 	Sprocket Development Team, 			   */	
/*			sprocket@jungfrau.ptf.hro.nl		   	   */
/*									   */
/* 									   */	
/* The Sprocket program is coded by a few students for a project at the    */
/* Hogeschool Rotterdam & Omstreken (home of Brinta BBS ;) )               */
/* Since it was done as a project, the program had to be coded quick and   */
/* dirty. As a result, this program is NOT completely free of bugs.        */
/* We've tried to make it as bugfree as possible, but hey, we're not God!  */
/* SO, USE AT YOUR OWN RISK!						   */
/* If you found a bug, please let us know, also give us precise details    */
/* on how to reproduce the bug. Things like 'the program crashes' doesn't  */
/* help us much.							   */	
/* And now for the legal stuff:						   */
/*							                   */
/* This program is free software; you can redistribute it and/or	   */
/* modify it under the terms of the GNU Library General Public		   */
/* License as published by the Free Software Foundation; either		   */
/* version 2 of the License, or (at your option) any later version.	   */
/* 								           */
/* 								           */
/***************************************************************************/

#include "ftp.h"
#include "ftplib.h"


#define NO_LOC_DIR
int cnw_flag=0;
char timestring[1024];
const char *loc_dir;
const char *loc_file;
char rem_dir[1024];
char rem_file[1024];
char ftp_host[1024];
char loginnaam[1024];
char wachtwoord[1024];

/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
///////////	All the code for the mainwindow :)

/// Building the FTP-Window ////////////////////////////////////////////////

FtpWidget::FtpWidget( QWidget *parent, const char *name )
    : QWidget( parent, name )
{
    setMinimumSize( 560, 550 );   // keep min. and max. size the same


/// Define color for Pushbuttons ///////////////////////////////////////////

    QColor col;
    col = QColor( 26, 78, 151 );
    QColorGroup colgrp;
    colgrp = QColorGroup( yellow, col, col.light(), col.dark(),
             col.dark( 120 ), green, white );


/// Local and Remote Edit Boxes ///////////////////////////////////////////

    local_dir_ed = new QLineEdit( this, "loc_dir_ed" );
    local_dir_ed->setGeometry (30,10, 155, 25);
    local_dir_ed->setFont(QFont("helvetica",10));
    connect(local_dir_ed, SIGNAL(returnPressed()), SLOT(loc_ret_pressed()) );

    remote_dir_ed = new QLineEdit( this, "rem_dir_ed" );
    remote_dir_ed->setGeometry (315,10, 155, 25);
    remote_dir_ed->setFont(QFont("helvetica",10));
    remote_dir_ed->setEnabled( FALSE );				// until connection :)
    connect(remote_dir_ed, SIGNAL(returnPressed()), SLOT(remote_ret_pressed()) );

/// Local and Remote Group Boxes /////////////////////////////////////////

    localgroup = new QGroupBox( this, "localgroup" );
    localgroup->setTitle( "Local Machine" );
    localgroup->setGeometry( 20,40, 235,340 );
    localgroup->setFont( QFont( "helvetica",10 ) );

    remotegroup = new QGroupBox( this, "remotegroup" );
    remotegroup->setTitle( "Remote Machine" );
    remotegroup->setGeometry( 305,40, 235,340 );
    remotegroup->setFont(QFont("helvetica",10));


/// Make the buttons of the FTP window //////////////////////////////////


    local_mkdir_btn = new QPushButton( "MKDIR", this, "mkdir_btn");
    local_rmdir_btn = new QPushButton( "RMDIR", this, "rmdir_btn" );
    local_mvdir_btn = new QPushButton( "Rename", this, "mvdir_btn" );

       local_mkdir_btn->setGeometry( 190, 75, 60, 25 );
       local_mkdir_btn->setFont( QFont("helvetica", 10) );
       connect( local_mkdir_btn, SIGNAL(clicked()), SLOT(loc_mkdir()) );
       QToolTip::add( local_mkdir_btn, "Make a directory" );

       local_rmdir_btn->setGeometry( 190, 110 , 60, 25 );
       local_rmdir_btn->setFont( QFont("helvetica", 10) );
       connect( local_rmdir_btn, SIGNAL(clicked()), SLOT(loc_rmdir()) );
       QToolTip::add( local_rmdir_btn, "Delete a directory" );

       local_mvdir_btn->setGeometry( 190, 145, 60, 25 );
       local_mvdir_btn->setFont( QFont("helvetica", 10) );
       connect( local_mvdir_btn, SIGNAL(clicked()), SLOT(loc_mvdir()) );
       QToolTip::add( local_mvdir_btn, "Rename a directory" );


       upload_btn = new QPushButton( "->", this, "upload_btn");
       download_btn = new QPushButton( "<-", this, "download_btn" );

       upload_btn->setGeometry( 260, 180, 40, 25 );
       connect( upload_btn, SIGNAL(clicked()), SLOT(upload()) );
       upload_btn->setEnabled( FALSE );
       QToolTip::add( upload_btn, "Upload file(s)" );

       download_btn->setGeometry( 260, 215 , 40, 25 );
       connect( download_btn, SIGNAL(clicked()), SLOT(download()) );
       download_btn->setEnabled( FALSE );
       QToolTip::add( download_btn, "Download file(s)" );


    local_refresh_btn = new QPushButton( "Refresh", this, "refresh_btn");
    local_view_btn = new QPushButton( "View", this, "view_btn");
    local_delete_btn = new QPushButton( "Delete", this, "delete_btn");
    local_rename_btn = new QPushButton( "Rename", this, "rename_btn");

       local_refresh_btn->setGeometry( 190, 230, 60, 25 );
       local_refresh_btn->setFont( QFont("helvetica", 10) );
       connect( local_refresh_btn, SIGNAL( clicked() ), SLOT( refresh_local()) );
       QToolTip::add( local_refresh_btn, "Refresh dirs and files" );

       local_view_btn->setGeometry( 190, 265, 60, 25 );
       local_view_btn->setFont( QFont("helvetica", 10) );
       connect( local_view_btn, SIGNAL( clicked() ), SLOT( loc_view_file()) );
       QToolTip::add( local_view_btn, "View selected file(s)" );

       local_delete_btn->setGeometry( 190, 300, 60, 25 );
       local_delete_btn->setFont( QFont("helvetica", 10) );
       connect( local_delete_btn, SIGNAL( clicked() ), SLOT( loc_delete_file()) );
       QToolTip::add( local_delete_btn, "Delete selected file(s)" );

       local_rename_btn->setGeometry( 190, 335, 60, 25 );
       local_rename_btn->setFont( QFont("helvetica", 10) );
       connect( local_rename_btn, SIGNAL( clicked() ), SLOT( loc_rename_file()) );
       QToolTip::add( local_rename_btn, "Rename selected file" );

/// Buttons for the remote group //////////////////////////////////////////

       rem_mkdir_btn = new QPushButton( "MKDIR", this,"mkdir_btn");
       rem_rmdir_btn = new QPushButton( "RMDIR", this,"rmdir_btn" );

       rem_mkdir_btn->setGeometry( 475, 75, 60, 25 );
       rem_mkdir_btn->setFont( QFont("helvetica", 10) );
       connect( rem_mkdir_btn, SIGNAL( clicked() ), SLOT( rem_mkdir()) );
       rem_mkdir_btn->setEnabled( FALSE );
       QToolTip::add( rem_mkdir_btn, "Make a directory" );

       rem_rmdir_btn->setGeometry( 475, 110 , 60, 25 );
       rem_rmdir_btn->setFont( QFont("helvetica", 10) );
       connect( rem_rmdir_btn, SIGNAL( clicked() ), SLOT( rem_rmdir()) );
       rem_rmdir_btn->setEnabled( FALSE );
       QToolTip::add( rem_rmdir_btn, "Delete a directory" );

       rem_refresh_btn=new QPushButton("Refresh", this,"refresh_btn");
       rem_view_btn=new QPushButton("View", this,"view_btn");
       rem_delete_btn=new QPushButton("Delete",this,"delete_btn");

       rem_refresh_btn->setGeometry( 475, 240, 60, 25 );
       rem_refresh_btn->setFont( QFont("helvetica", 10) );
       connect( rem_refresh_btn, SIGNAL( clicked() ), SLOT( rem_refresh()) );
       rem_refresh_btn->setEnabled( FALSE );
       QToolTip::add( rem_refresh_btn, "Refresh dirs and files" );

       rem_view_btn->setGeometry( 475, 275, 60, 25 );
       rem_view_btn->setFont( QFont("helvetica", 10) );
       connect( rem_view_btn, SIGNAL( clicked() ), SLOT( rem_view_file()) );
       rem_view_btn->setEnabled( FALSE );
       QToolTip::add( rem_view_btn, "Move selected file(s)" );

       rem_delete_btn->setGeometry( 475, 310, 60, 25 );
       rem_delete_btn->setFont( QFont("helvetica", 10) );
       connect( rem_delete_btn, SIGNAL( clicked() ), SLOT( rem_delete_file()) );
       rem_delete_btn->setEnabled( FALSE );
       QToolTip::add( rem_delete_btn, "Delete selected file(s)" );


/// Messagebox ////////////////////////////////////////////////////////////

   ftpmsg = new QListBox(this, "msgFORftp");
   ftpmsg->setGeometry(30,418,490,70);
   ftpmsg->setBackgroundColor(white);

/// Local ListBox ////////////////////////////////////////////////////////

       local_dir_box = new QListBox( this, "localdir" );
       local_dir_box->setGeometry( 30, 60, 155, 140 );
       local_dir_box->setFont(QFont("helvetica",10));
       connect( local_dir_box, SIGNAL(selected(int)), SLOT(change_local_dir(int)) );
       connect( local_dir_box, SIGNAL(highlighted(int)), SLOT(active_dirs()) );
       connect( local_dir_box, SIGNAL(highlighted(int)), SLOT(put_loc_dir(int)) );			
	
       local_file_box = new QListBox( this, "localfile" );
       local_file_box->setGeometry( 30, 210, 155, 140 );
       local_file_box->setFont(QFont("helvetica",10));
       local_file_box->setMultiSelection(TRUE);
       connect( local_file_box, SIGNAL(highlighted(int)), SLOT(active_files()) );
       connect( local_file_box, SIGNAL(highlighted(int)), SLOT(put_loc_file(int)) );	

/// Remote ListBox ////////////////////////////////////////////////////////

       remote_dir_box = new QListBox( this, "remotedir" );
       remote_dir_box->setGeometry( 315, 60, 155, 140 );
       remote_dir_box->setFont(QFont("helvetica",10));
       connect( remote_dir_box, SIGNAL(highlighted(int)), SLOT(put_rem_dir(int)) );	
       connect( remote_dir_box, SIGNAL(highlighted(int)), SLOT(rem_active_dirs()) );
       connect( remote_dir_box, SIGNAL(selected(int)), SLOT(change_remote_dir()) );

       remote_file_box = new QListBox( this, "remotefile" );
       remote_file_box->setGeometry( 315, 210, 155, 140 );
       remote_file_box->setFont(QFont("helvetica",10));
       remote_file_box->setMultiSelection(TRUE);
       connect( remote_file_box, SIGNAL(highlighted(int)), SLOT(put_rem_file(int)) );	
       connect( remote_file_box, SIGNAL(highlighted(int)), SLOT(rem_active_files()) );

/// Lowest Buttons FtpWidget /////////////////////////////////////////////


       connect_btn = new QPushButton( "Connect", this, "connect_btn");
       connect_btn->setGeometry( 30, 510, 80, 30 );
       connect_btn->setFont( QFont("helvetica", 10) );
       connect( connect_btn, SIGNAL(clicked()), SLOT(connect_to()) );
       QToolTip::add( connect_btn, "Connect to an FTP-Server" );

       disconnect_btn = new QPushButton( "Disconnect", this, "discon_btn" );
       disconnect_btn->setGeometry( 115, 510 , 80, 30 );
       disconnect_btn->setFont( QFont("helvetica", 10) );
       disconnect_btn->setEnabled( FALSE );
       connect( disconnect_btn, SIGNAL(clicked()), SLOT(disconnect()) );
       QToolTip::add( disconnect_btn, "Disconnect from the FTP-Server" );

       about_btn = new QPushButton( "About", this, "about_btn" );
       about_btn->setGeometry( 205, 510, 80, 30 );
       about_btn->setFont( QFont("helvetica", 10) );
       connect( about_btn, SIGNAL(clicked()), SLOT(about()) );
       QToolTip::add( about_btn, "Information about Sprocket" );

       style_btn = new QPushButton("Style", this, "style_btn");
       style_btn->setGeometry( 290, 510, 80, 30 );
       style_btn->setFont( QFont("helvetica", 10) );
       connect( style_btn, SIGNAL(clicked()), SLOT(ch_style()) );
       QToolTip::add( style_btn, "Change the GUI style of Sprocket" );

       exit_btn = new QPushButton( "Exit", this, "exit_btn" );
       exit_btn->setGeometry( 375, 510, 80, 30 );
       exit_btn->setFont( QFont("helvetica", 10) );
       connect( exit_btn, SIGNAL(clicked()), qApp, SLOT(quit()) );
       QToolTip::add( exit_btn, "Exit Sprocket" );

       setUpdatesEnabled(TRUE);
       refresh_local();
}


// Functions for buttons in FTP Window ////////////////////////////////////

// Local ////////////////////////////////////////////////////////////////

void FtpWidget::refresh_local()
{
   local_dir_ed->setText("");           // clears QLineEditBox
   local_dir_box->clear();              // clears QListBox
   local_file_box->clear();             // clears QListBox

   QString loc;                         // put current dir. in
   loc = QDir::currentDirPath();        // local editbox on top.
   local_dir_ed->setText( loc );

   QDir d,e;
   d.setFilter( QDir::Files | QDir::Hidden | QDir::NoSymLinks );
   d.setSorting( QDir::Name );
   e.setFilter( QDir::Dirs | QDir::Hidden | QDir::NoSymLinks );
   e.setSorting( QDir::Name );

   const QFileInfoList *list = d.entryInfoList();
   const QFileInfoList *listb = e.entryInfoList();
   QFileInfoListIterator it( *list );
   QFileInfoListIterator itb( *listb );
   QFileInfo *fi;
   QFileInfo *fib;

   while ( (fi = it.current()) ) {
    QString str1;
    str1.sprintf( "%s", fi->fileName().data());
    local_file_box->insertItem( str1 );
    ++it;
    } // end while

   while ( (fib = itb.current()) ) {
    QString str2;
    str2.sprintf( "%s", fib->fileName().data());
    local_dir_box->insertItem( str2 );
    ++itb;
    } // end while

   if(!local_file_box->hasFocus())
     {
      local_rename_btn->setEnabled(FALSE);
      local_delete_btn->setEnabled(FALSE);
      local_view_btn->setEnabled(FALSE);
      upload_btn->setEnabled(FALSE);
     }

   if(!local_dir_box->hasFocus())
     {
      local_rmdir_btn->setEnabled(FALSE);
      local_mvdir_btn->setEnabled(FALSE);
     }

 } // end function

void FtpWidget::warning_dir()
{
 emit explain("** Could not create directory! **");
}

void FtpWidget::loc_mkdir()
{
   char cap_string[25];
   sprintf( cap_string, "Make a directory");
   MkdirWidget *mkdir_window = new MkdirWidget (0,0);

   connect (mkdir_window, SIGNAL (refresh_dir()), this , SLOT(refresh_local()));
   connect (mkdir_window, SIGNAL (warning()), this, SLOT(warning_dir()));

   mkdir_window->setCaption(cap_string);
   mkdir_window->show();
}

void FtpWidget::loc_rmdir()
{
   char cap_string[25];
   sprintf( cap_string, "Delete a directory");
   RmdirWidget *rmdir_window = new RmdirWidget (0,0);

   connect (rmdir_window, SIGNAL (refresh_dir()), this , SLOT(refresh_local()));
   connect (rmdir_window, SIGNAL (warning()), this, SLOT(warning_dir()));

   rmdir_window->setCaption(cap_string);
   rmdir_window->show();

}

void FtpWidget::loc_mvdir()
{
  char cap_string[25];
  sprintf( cap_string, "Rename a directory");
  RenamelocdirWidget *renamelocdir_window = new RenamelocdirWidget (0,0);

  connect (renamelocdir_window, SIGNAL (refresh_dir()), this, SLOT(refresh_local()));
  connect (renamelocdir_window, SIGNAL (warning()), this, SLOT(warning_dir()));

  renamelocdir_window->setCaption(cap_string);
  renamelocdir_window->show();
}

void FtpWidget::active_dirs()
{
 local_rmdir_btn->setEnabled(TRUE);
 local_mvdir_btn->setEnabled(TRUE);
}

void FtpWidget::active_files()
{
 local_view_btn->setEnabled(TRUE);
 local_delete_btn->setEnabled(TRUE);
 local_rename_btn->setEnabled(TRUE);
 if ( cnw_flag == 1 )
  {
   upload_btn->setEnabled(TRUE);
   }
 else { upload_btn->setEnabled( FALSE );
	}
	
}

void FtpWidget::change_local_dir(int index)
{
  QString s = local_dir_box->text( index );
  QDir current_dir;

  if (!current_dir.cd( s , FALSE ))
        {
          QMessageBox::message("Error","Failed to read directory!");
        }

 QDir::setCurrent(current_dir.path());
 refresh_local();
}

void FtpWidget::loc_view_file()
{
 QFile file(loc_file);
 if(!file.open(IO_ReadOnly) )
	{
	 QMessageBox::message("Error","Could not read file!");
	 return;
	}
else {

  QString s;
  QString t;
  s = "Viewing ";
  t = s+loc_file;

   char cap_string[1024];
   sprintf( cap_string, t );
   ViewWidget *view_window = new ViewWidget (0,0);

   view_window->setCaption(cap_string);
   view_window->show();
}
}

void FtpWidget::loc_delete_file()
{
   remove( loc_file);
   refresh_local();	
}

void FtpWidget::loc_rename_file()
{
   char cap_string[25];
   sprintf( cap_string, "Rename a file");
   RenamelocWidget *renameloc_window = new RenamelocWidget (0,0);

   connect (renameloc_window, SIGNAL (refresh_dir()), this, SLOT(refresh_local()));
   connect (renameloc_window, SIGNAL (warning()), this, SLOT(warning_dir()));

   renameloc_window->setCaption(cap_string);
   renameloc_window->show();
}


void FtpWidget::loc_ret_pressed()
{
 QString s = local_dir_ed->text();
 QDir current_dir;

 if (!current_dir.cd( s, TRUE))
	{
 	  QMessageBox::message("Error","Failed to read directory!");
	}

  QDir::setCurrent( s );

 refresh_local();
}


/// Remote /////////////////////////////////////////////////////////

void FtpWidget::rem_mkdir()
{
   char cap_string[25];
   sprintf( cap_string, "Make a directory");
   RemMkdirWidget *rem_mkdir_window = new RemMkdirWidget (0,0);

   connect (rem_mkdir_window, SIGNAL(refresh_rem()), this, SLOT(rem_refresh()));
   connect (rem_mkdir_window, SIGNAL(warning()), this, SLOT(warning_dir()));

   rem_mkdir_window->setCaption(cap_string);
   rem_mkdir_window->show();
}

void FtpWidget::rem_rmdir()
{
   if(!ftpRmdir(rem_dir))
	{
	  QMessageBox::message("Error","Could not delete directory");
	  return;
	}
   rem_refresh();	

}


void FtpWidget::change_remote_dir()
{
   ftpChdir(rem_dir);
   rem_refresh();
}

void FtpWidget::remote_ret_pressed()
{


}

void FtpWidget::rem_active_dirs()
{
   rem_mkdir_btn->setEnabled( TRUE );
   rem_rmdir_btn->setEnabled( TRUE );
}

void FtpWidget::rem_active_files()
{
   rem_view_btn->setEnabled( TRUE );
   rem_delete_btn->setEnabled( TRUE );

  if( cnw_flag == 1 )
   {
    download_btn->setEnabled( TRUE );
   }

}

void FtpWidget::rem_refresh()
{
   QTime dt;
   dt.start();
   sprintf( timestring, "/tmp/%d", dt.elapsed() );
   printf("[%s]\n",timestring);

  disconnect_btn->setEnabled( TRUE );
  remote_dir_ed->setEnabled( TRUE );
  remote_dir_ed->setText("");
  remote_dir_box->clear();
  remote_file_box->clear();

  remote_dir_ed->setText(rem_dir);
  ftpmsg->insertItem("Getting ftplist...");
  ftpDir(timestring, "./");

  QFile rem_filelist(timestring);
  rem_filelist.open(IO_ReadOnly);

  QTextStream list_text(&rem_filelist);
  QString regel;
  QStrList rem_list;
  QString type;       // Type (directory, file, link etc.)
  QString filename;
  int next;
  int previous;
  int columns;

  ftpmsg->insertItem("Putting results in listbox...");
   	
  remote_dir_box->insertItem(".");
  remote_dir_box->insertItem("..");	 	

  while (!list_text.eof())
  {
     regel = list_text.readLine();
     type = regel.left(1);
     if (type == "d")
	{

	  next=0;
	  previous=0;
	  columns=0;
	
	  while (columns < 8 )
		{
			next=regel.find(" ", regel.find(" ", previous+1));
		        if (!(next - previous == 1) )	
				{
					columns++;
				}
			previous = next;
		}
	  filename = regel.right(regel.length()-(next+1));

	  if(!(filename == "." || filename == "..") )
	    {
   	   	remote_dir_box->insertItem(filename);
  	    }		

	}
     else

     if (type == "-") {

          next=0;
          previous=0;
          columns=0;

          while (columns < 8 )
                {
                        next=regel.find(" ", regel.find(" ", previous+1));
                        if (!(next - previous == 1) )
                                {
                                        columns++;
                                }
                        previous = next;
                }
          filename = regel.right(regel.length()-(next+1));
          remote_file_box->insertItem(filename);
     }
  }

   connect_btn->setEnabled( FALSE );
   rem_mkdir_btn->setEnabled( TRUE );
   rem_refresh_btn->setEnabled( TRUE );

	if(!remote_file_box->hasFocus())
	 {
	  rem_view_btn->setEnabled( FALSE );
	  rem_delete_btn->setEnabled( FALSE );
	  download_btn->setEnabled( FALSE );
 	 }

	if(!remote_dir_box->hasFocus())
	 {
	  rem_rmdir_btn->setEnabled( FALSE );
	 }

   remove(timestring);
}

void FtpWidget::rem_view_file()
{
  ftpGet("/tmp/temp_file", rem_file, FTPLIB_IMAGE);
	
  RemViewWidget *rem_view_window = new RemViewWidget(0,0);
  rem_view_window->setCaption("Viewing remote file");
  rem_view_window->show();
}

void FtpWidget::rem_delete_file()
{
	if(!ftpDelete(rem_file))
	{
	QMessageBox::message("Error","Could not delete file!\nCheck to see if you have permission to delete it.");
	return;
	}	

   rem_refresh();	

}

/// Misc /////////////////////////////////////////////////////////

void FtpWidget::upload()
{
	int i;
	for (i=0;i<local_file_box->count();i++)
	 {
	   if ( local_file_box->isSelected(i))
		{
			char err[1024];
			char msg[1024];
			sprintf(msg, "Uploading file %s", local_file_box->text(i));
			ftpmsg->insertItem(msg);
			if (!ftpPut(local_file_box->text(i), local_file_box->text(i), FTPLIB_IMAGE))
				{
					sprintf(err,"Could not upload file: %s", local_file_box->text(i));
					QMessageBox::message("Error",err);
					return;
				}		
			rem_refresh();
		}
	}
}

void FtpWidget::download()
{
 	int i;
	for (i=0;i<remote_file_box->count();i++)
	 {
	   if (remote_file_box->isSelected(i))
		{
  			char err[1024];
			char msg[1024];
			sprintf(msg,"Downloading file %s",remote_file_box->text(i));
			ftpmsg->insertItem(msg);
  			if (!ftpGet(remote_file_box->text(i), remote_file_box->text(i), FTPLIB_IMAGE))
        			{
                			sprintf(err,"Could not download file: %s", remote_file_box->text(i));
 					QMessageBox::message("Error",err);
                			return;
        			}
        		refresh_local();			
   		}
	}

}


void FtpWidget::sorry()
{
 QMessageBox::message("Sorry","Not yet implemented!");
}

// Lowest FTP Window Buttons ////////////////////////////////////////////////

void FtpWidget::connect_to()
{
  ConnectWidget *connect_window = new ConnectWidget(0,0);
  connect_window->setCaption("Connect to...");
  connect (connect_window, SIGNAL (refresh_rem()), this, SLOT(rem_refresh()));
  connect_window->show();
}

void FtpWidget::disconnect()
{
   ftpQuit();
   remote_dir_box->clear();
   remote_file_box->clear();
   remote_dir_ed->setText("");
   remote_dir_ed->setEnabled( FALSE );
   rem_mkdir_btn->setEnabled( FALSE );
   rem_rmdir_btn->setEnabled( FALSE );
   rem_refresh_btn->setEnabled( FALSE );
   rem_view_btn->setEnabled( FALSE );
   rem_delete_btn->setEnabled( FALSE );
   download_btn->setEnabled( FALSE );
   connect_btn->setEnabled( TRUE );
   disconnect_btn->setEnabled( FALSE );

   cnw_flag=0;
   refresh_local();
}

void FtpWidget::about()
{
  char cap_string[25];
  sprintf( cap_string, "About...");
  AboutWidget *about_window = new AboutWidget (0,0);

  about_window->setCaption(cap_string);
  about_window->show();

}


// Put the selected file- and directorynames in 4 different global variables ///
void FtpWidget::put_loc_dir(int index)
{
  loc_dir = local_dir_box->text( index );
}

void FtpWidget::put_loc_file(int index)
{
 loc_file = local_file_box->text(index);
}

void FtpWidget::put_rem_file(int index)
{
 strcpy(rem_file, remote_file_box->text(index));
}

void FtpWidget::put_rem_dir(int index)
{
 strcpy(rem_dir, remote_dir_box->text(index));
}


// Make sure that all the widgets are at the correct place after
// a resize event.

void FtpWidget::resizeEvent( QResizeEvent * )
{
    localgroup -> setGeometry(20, 40, width()/2-45, height()-215);
    remotegroup -> setGeometry(width()/2+25, 40, width()/2-45, height()-215);

    local_dir_ed -> setGeometry(30, 10, width()/2-125 , 25);
    remote_dir_ed -> setGeometry(width()/2+35, 10,  remotegroup->width() - 80 , 25);

    local_dir_box -> setGeometry(30, 60, localgroup->width()-80, height()/2-135);
    remote_dir_box -> setGeometry(width()/2+35, 60, remotegroup->width()-80,height()/2-135);

    local_file_box -> setGeometry( 30, height()/2-65, localgroup->width()-80, height()/2-125 );
    remote_file_box -> setGeometry( width()/2+35, height()/2-65, remotegroup->width()-80, height()/2-125 );

    upload_btn -> move ( width()/2-20, 180);
    download_btn -> move ( width()/2-20, 215);

    local_mkdir_btn -> move( width()/2-90, 60);
    local_rmdir_btn -> move( width()/2-90, 95);
    local_mvdir_btn -> move( width()/2-90, 130);

    local_refresh_btn -> move ( width()/2-90, height()/2-65);
    local_view_btn -> move ( width()/2-90, height()/2-30);
    local_delete_btn -> move ( width()/2-90,height()/2+5);
    local_rename_btn -> move ( width()/2-90,height()/2+40);

    rem_mkdir_btn -> move ( width()-85, 60);
    rem_rmdir_btn -> move ( width()-85, 95);

    rem_refresh_btn -> move ( width()-85,height()/2-65);
    rem_view_btn -> move ( width()-85,height()/2-30);
    rem_delete_btn -> move ( width()-85,height()/2+5);

    ftpmsg -> setGeometry (35,height()-120, width()-70,70);

    connect_btn -> move (width()/2-215, height()-40 );
    disconnect_btn -> move (width()/2-130, height()-40 );
    about_btn -> move (width()/2-40, height()-40 );
    style_btn -> move (width()/2+45, height()-40 );
    exit_btn -> move (width()/2+130, height()-40 );

}

// We use local_dir_ed as a referencepoint for our StyleChange.

void FtpWidget::ch_style()
{
    if (local_dir_ed->style() == WindowsStyle)
       {
            qApp->setStyle(MotifStyle);
            localgroup->setStyle(MotifStyle);
            remotegroup->setStyle(MotifStyle);
            local_dir_ed->setStyle(MotifStyle);
            remote_dir_ed->setStyle(MotifStyle);
            local_dir_box->setStyle(MotifStyle);
            remote_dir_box->setStyle(MotifStyle);
            local_file_box->setStyle(MotifStyle);
            remote_file_box->setStyle(MotifStyle);
            upload_btn->setStyle(MotifStyle);
            download_btn->setStyle(MotifStyle);
            local_mkdir_btn->setStyle(MotifStyle);
            local_rmdir_btn->setStyle(MotifStyle);
            local_mvdir_btn->setStyle(MotifStyle);
            local_refresh_btn->setStyle(MotifStyle);
            local_view_btn ->setStyle(MotifStyle);
            local_delete_btn ->setStyle(MotifStyle);
            local_rename_btn ->setStyle(MotifStyle);
            rem_mkdir_btn ->setStyle(MotifStyle);
            rem_rmdir_btn ->setStyle(MotifStyle);
            rem_refresh_btn->setStyle(MotifStyle);
            rem_view_btn->setStyle(MotifStyle);
            rem_delete_btn->setStyle(MotifStyle);
            ftpmsg->setStyle(MotifStyle);
            connect_btn->setStyle(MotifStyle);
            disconnect_btn->setStyle(MotifStyle);
            about_btn->setStyle(MotifStyle);
            style_btn->setStyle(MotifStyle);
            exit_btn->setStyle(MotifStyle);
            styleChange(style());
            update();
            return;
       }
    if (local_file_box->style() == MotifStyle)
          {
               qApp->setStyle(WindowsStyle);
               local_file_box->setStyle(WindowsStyle);
               localgroup->setStyle(WindowsStyle);
               remotegroup->setStyle(WindowsStyle);
               local_dir_ed->setStyle(WindowsStyle);
               remote_dir_ed->setStyle(WindowsStyle);
               local_dir_box->setStyle(WindowsStyle);
               remote_dir_box->setStyle(WindowsStyle);
               local_file_box->setStyle(WindowsStyle);
               remote_file_box->setStyle(WindowsStyle);
               upload_btn->setStyle(WindowsStyle);
               download_btn->setStyle(WindowsStyle);
               local_mkdir_btn->setStyle(WindowsStyle);
               local_rmdir_btn->setStyle(WindowsStyle);
               local_mvdir_btn->setStyle(WindowsStyle);
               local_refresh_btn->setStyle(WindowsStyle);
               local_view_btn ->setStyle(WindowsStyle);
               local_delete_btn ->setStyle(WindowsStyle);
               local_rename_btn ->setStyle(WindowsStyle);
               rem_mkdir_btn ->setStyle(WindowsStyle);
               rem_rmdir_btn ->setStyle(WindowsStyle);
               rem_refresh_btn->setStyle(WindowsStyle);
               rem_view_btn->setStyle(WindowsStyle);
               rem_delete_btn->setStyle(WindowsStyle);
               ftpmsg->setStyle(WindowsStyle);
               connect_btn->setStyle(WindowsStyle);
               disconnect_btn->setStyle(WindowsStyle);
               about_btn->setStyle(WindowsStyle);
               style_btn->setStyle(WindowsStyle);
               exit_btn->setStyle(WindowsStyle);

               styleChange(style());
               update();
               return;
          }


}


void FtpWidget::styleChange( GUIStyle s )
{
    QWidget::styleChange( s );
    // setSizes();
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
//////////////////	Code for the actual ftp-connection


ConnectWidget::ConnectWidget( QWidget *parent, const char *name )
    : QDialog( parent, name, TRUE )
{

    setMinimumSize( 500, 130 );   // de minimum en max size zelfde
    setMaximumSize( 500, 130 );


    QLabel *h_name = new QLabel( "Host Name:", this, "h_n" );
    h_name->setFont( QFont("helvetica", 10) );
    h_name->setGeometry( 20, 10, 90, 20 );

    host_name = new QLineEdit( this, "hn" );
    host_name->setGeometry( 120, 10, 200, 25 );
    host_name->setFont( QFont("helvetica", 10) );
    host_name->setFocus();

/// User ID /////////////////////////////////////////////////////////////

    QLabel *u_id = new QLabel( "User ID:", this, "u_i" );
    u_id->setFont( QFont("helvetica", 10) );
    u_id->setGeometry( 20, 40, 90, 20 );

    user_id = new QLineEdit( this, "ui" );
    user_id->setGeometry( 120, 40, 200, 25 );
    user_id->setFont( QFont("helvetica", 10) );

/// Password /////////////////////////////////////////////////////////////

    QLabel *p_wd = new QLabel("Password:", this, "p_w");
    p_wd->setFont( QFont("helvetica", 10) );
    p_wd->setGeometry( 20, 70, 90, 20 );

    pass_wd = new QLineEdit( this, "pw" );
    pass_wd->setGeometry( 120, 70, 200, 25 );
    pass_wd->setFont( QFont("helvetica", 10) );

    /*       done       */
    pass_wd->setEchoMode(QLineEdit::Password);

/// Cancel Button ////////////////////////////////////////////////////////

    QPushButton *cancel_btn = new QPushButton( "Cancel", this, "c_btn");
    cancel_btn->setGeometry( 390, 55, 90, 25 );
    cancel_btn->setFont( QFont("helvetica", 10) );
    connect( cancel_btn, SIGNAL(clicked()), SLOT(cancel()) );

/// Ok Button //////////////////////////////////////////////////////////

    QPushButton *ok_btn = new QPushButton( "Ok", this, "o_btn");
    ok_btn->setGeometry( 390, 20, 90, 25 );
    ok_btn->setFont( QFont("helvetica", 10) );
    ok_btn->setDefault(TRUE);
    connect( ok_btn, SIGNAL(clicked()), SLOT(ok_connect()) );


/// Checkboxes /////////////////////////////////////////////////////////

    anon = new QCheckBox( this, "anonCheckBox" );
    anon->setGeometry( 370, 100, 130, 15 );
    anon->setFont( QFont("helvetica", 8, QFont::Bold) );
    anon->setText( "Anonymous Login" );
    connect( anon, SIGNAL(clicked()), SLOT(anonymous_ftp()) );


}
/// Functions //////////////////////////////////////////////////////////

void ConnectWidget::ok_connect()
{
	strcpy(ftp_host, host_name->text());
	strcpy(loginnaam, user_id->text());
	strcpy(wachtwoord, pass_wd->text());

	if(strcmp(loginnaam,"")==0 | strcmp(wachtwoord,"")==0)
	 {
	  QMessageBox::message("sorry","You have to fill in both your login-name and password");
	  return;
	 }

     	if (!ftpOpen( ftp_host))
         {
          char err[256];
          sprintf(err,"Unable to connect to host %s", ftp_host);
          QMessageBox::message("Error",err);
          return;
        }

   	if (!ftpLogin( loginnaam, wachtwoord ))
        {
          QMessageBox::message("Error","Login Failure!");
          return;
        }
	
   strcpy(rem_dir, ".");
   emit refresh_rem();
   cnw_flag=1;
   delete (this);

}

void ConnectWidget::cancel()
{
 delete(this);
}

void ConnectWidget::anonymous_ftp()
{
 int ch;
 ch = anon->isChecked();

 if(ch==1)
	{
 		user_id->setText("anonymous");
		pass_wd->setEchoMode(QLineEdit::Normal);
		pass_wd->setText("guest@email.com");
	}
else
 {
	user_id->setText("");
	pass_wd->setEchoMode(QLineEdit::Password);
	pass_wd->setText("");
}


}

//************************************************************************
//***[ Local directory functionality ]************************************
//************************************************************************

//---[ Make local directory widget ]---------------------------------------

MkdirWidget::MkdirWidget( QWidget *parent, const char *name )
    : QDialog( parent, name, TRUE )
{

   setMinimumSize( 375, 175 );	// keep min. and max. size the same
   setMaximumSize( 375, 175 );

/// Define color for Pushbuttons ///////////////////////////////////////////

   QColor col;
   col = QColor( 26, 78, 151 );
   QColorGroup colgrp;
   colgrp = QColorGroup( yellow, col, col.light(), col.dark(),
            col.dark( 120 ), green, white );


// MsgLabel /////////////////////////////////////////////////////////////

   QLabel *msglabel = new QLabel(this);
 	msglabel->setText("Enter a local directory name:");
	msglabel->setFont( QFont("helvetica", 10));
	msglabel->setFrameStyle( QFrame::NoFrame );
	msglabel->setAlignment( AlignBottom | AlignLeft );
        msglabel->setGeometry( 23, 20, 208, 30 );


// MkdirWidget Buttons ///////////////////////////////////////////////////

   QPushButton *ok_btn = new QPushButton( "Ok", this, "ok_btn" );
   QPushButton *cancel_btn = new QPushButton( "Cancel", this, "cancel_btn" );

   ok_btn->setGeometry(268, 70, 94, 25 );
   ok_btn->setFont( QFont("helvetica", 10));
   ok_btn->setDefault(TRUE);
   connect( ok_btn, SIGNAL( clicked() ), SLOT( mkdir_ok()) );

   cancel_btn->setGeometry( 268, 105, 94, 25 );
   cancel_btn->setFont( QFont("helvetica", 10));
   connect( cancel_btn, SIGNAL( clicked() ), SLOT( exit_mkdir_loc()) );

// Make EditBox ////////////////////////////////////////////////////////////

   mkdir_ed = new QLineEdit( this, "mkdir_ed" );
   mkdir_ed->setGeometry( 25, 105, 208, 25);
   mkdir_ed->setFont( QFont( "helvetica", 10));
   mkdir_ed->setFocus();
}


// MkdirWidget Functions //////////////////////////////////////////////////


void MkdirWidget::exit_mkdir_loc()
{
 delete(this);
}

void MkdirWidget::mkdir_ok()
{
 QString s = mkdir_ed->text();
 QDir tmp;
 if(!tmp.mkdir(s))
   {
     emit warning();
     return;
     }
 else
 tmp.mkdir( s, TRUE );
 emit refresh_dir ();
 exit_mkdir_loc();
}




//---[ Delete local directory widget ]-----------------------------



RmdirWidget::RmdirWidget( QWidget *parent, const char *name )
    : QDialog( parent, name, TRUE )
{

   setMinimumSize( 375, 175 );	// de min. en max. size hetzelfde
   setMaximumSize( 375, 175 );

 QString s;
 QString t;
 QString u;
 s = "Delete \"";
 t = "\" ?";
 u = s+loc_dir+t;

QLabel *msglabel = new QLabel(this);
 	msglabel->setText( u );
	msglabel->setFont( QFont("helvetica", 10));
	msglabel->setFrameStyle( QFrame::NoFrame );
	msglabel->setAlignment( AlignTop | WordBreak );
        msglabel->setGeometry( 23, 20, 208, 75 );

   QPushButton *yes_btn = new QPushButton( "Yes", this, "yes_btn" );

   yes_btn->setGeometry(268, 70, 94, 25 );
   yes_btn->setFont( QFont("helvetica", 10));
   yes_btn->setDefault(TRUE);
   connect( yes_btn, SIGNAL( clicked() ), SLOT( rmdir_yes()) );

   QPushButton *cancel_btn = new QPushButton( "Cancel", this, "cancel_btn" );

   cancel_btn->setGeometry(268, 105, 94, 25 );
   cancel_btn->setFont( QFont("helvetica", 10));
   connect( cancel_btn, SIGNAL( clicked() ), SLOT( rmdir_cancel()) );

}

void RmdirWidget::exit_rmdir_loc()
{
 delete(this);
}

void RmdirWidget::rmdir_yes()
{
 QDir tmp;
 if (!tmp.rmdir( loc_dir, TRUE ))
	{
	  QMessageBox::message("Error","Could not delete directory!");
	}

 emit refresh_dir();
 exit_rmdir_loc();
}

void RmdirWidget::rmdir_cancel()
{
 delete(this);
}



//---[ Rename local direcory widget ]--------------------------------------



RenamelocdirWidget::RenamelocdirWidget( QWidget *parent, const char *name )
	: QDialog( parent, name, TRUE )
{
	setMinimumSize( 375, 175 );
	setMaximumSize( 375, 175 );

// Define color for Pushbuttons ///////////////////////////////////////////

        QColor col;
	col = QColor( 26, 78, 151 );
	QColorGroup colgrp;
        colgrp = QColorGroup( yellow, col, col.light(), col.dark(), col.dark( 120 ), green, white );

// MsgLabel //////////////////////////////////////////////////////////////

	QString s;
        QString t;
	QString u;
       	s = "Rename \"";
	t = "\" to:";
	u = s+loc_dir+t;

	QLabel *msglabel = new QLabel(this);
	msglabel->setText( u );
	msglabel->setFont( QFont("helvetica", 10));
	msglabel->setFrameStyle( QFrame::NoFrame );
	msglabel->setAlignment( AlignTop | WordBreak );
	msglabel->setGeometry( 23, 20, 208, 75 );

// RenamelocdirWidget buttons ///////////////////////////////////////////////

	QPushButton *ok_btn = new QPushButton( "Ok", this, "ok_btn" );
	QPushButton *cancel_btn = new QPushButton( "Cancel", this, "cancel_btn" );

	ok_btn->setGeometry(268, 70, 94, 25 );
	ok_btn->setFont( QFont("helvetica", 10));
	ok_btn->setDefault(TRUE);
	connect( ok_btn, SIGNAL( clicked() ), SLOT( renamelocdir_ok()) );
	cancel_btn->setGeometry( 268, 105, 94, 25 );
	cancel_btn->setFont( QFont("helvetica", 10));
	connect( cancel_btn, SIGNAL( clicked() ), SLOT( exit_renamelocdir()) );

// Make EditBox /////////////////////////////////////////////////////////

	renamelocdir_ed = new QLineEdit( this, "renamelocdir_ed" );
	renamelocdir_ed->setGeometry( 25, 105, 208, 25);
	renamelocdir_ed->setFont( QFont( "helvetica", 10));
	renamelocdir_ed->setFocus();
}

// Renameloc Functions ////////////////////////////////////////////////

void RenamelocdirWidget::renamelocdir_ok()
{
 QString s = renamelocdir_ed->text();
 QFile f ( s ) ;
 if (f.exists())
  {
  QMessageBox::message("Error","Directory already exists");
  return;
  }
 else
 rename (loc_dir, s );
 emit refresh_dir();
 exit_renamelocdir();
}

void RenamelocdirWidget::exit_renamelocdir()
{
 delete(this);
}


//---[ Rename local file widget ]-----------------------------------------


RenamelocWidget::RenamelocWidget( QWidget *parent, const char *name )
	: QDialog( parent, name, TRUE )

{
	setMinimumSize( 375, 175 );
	setMaximumSize( 375, 175 );

// Define color for Pushbuttons ///////////////////////////////////////////

	QColor col;
	col = QColor( 26, 78, 151 );
	QColorGroup colgrp;
	colgrp = QColorGroup( yellow, col, col.light(), col.dark(), col.dark( 120 ), green, white );

// MsgLabel //////////////////////////////////////////////////////////////

	QString s;
	QString t;
	QString u;
	s = "Rename \"";
	t = "\" to:";
	u = s+loc_file+t;

	QLabel *msglabel = new QLabel(this);
		msglabel->setText( u );
		msglabel->setFont( QFont("helvetica", 10));
		msglabel->setFrameStyle( QFrame::NoFrame );
		msglabel->setAlignment( AlignTop | WordBreak );
		msglabel->setGeometry( 23, 20, 208, 75 );

// RenamelocWidget buttons ///////////////////////////////////////////////

	QPushButton *ok_btn = new QPushButton( "Ok", this, "ok_btn" );
	QPushButton *cancel_btn = new QPushButton( "Cancel", this, "cancel_btn" );

	ok_btn->setGeometry(268, 70, 94, 25 );
	ok_btn->setFont( QFont("helvetica", 10));
   	ok_btn->setDefault(TRUE);
	connect( ok_btn, SIGNAL( clicked() ), SLOT( renameloc_ok()) );

   	cancel_btn->setGeometry( 268, 105, 94, 25 );
	cancel_btn->setFont( QFont("helvetica", 10));
   	connect( cancel_btn, SIGNAL( clicked() ), SLOT( exit_renameloc()) );
	
// Make EditBox /////////////////////////////////////////////////////////

	renameloc_ed = new QLineEdit( this, "renameloc_ed" );
   	renameloc_ed->setGeometry( 25, 105, 208, 25);
   	renameloc_ed->setFont( QFont( "helvetica", 10));
   	renameloc_ed->setFocus();
}

// Renameloc Functions //////////////////////////////////////////////////

void RenamelocWidget::renameloc_ok()
{
 QString s = renameloc_ed->text();
 QFile f ( s ) ;
 if (f.exists())
  {
   QMessageBox::message("Error","File already exists");
   return;
   }
 else
 rename ( loc_file, s );
 emit refresh_dir();
 exit_renameloc();
}

void RenamelocWidget::exit_renameloc()
{
 delete(this);
}



//---[ View local file ]------------------------------------------



ViewWidget::ViewWidget( QWidget *parent, const char *name )
    : QDialog( parent, name, TRUE )
{

   view_edit = new QMultiLineEdit( this );
   view_edit->setGeometry (10,10,580,430);	
   view_edit->setFont(QFont("helvetica",10));

   ok_btn = new QPushButton("OK", this,"ok_btn");
   ok_btn->setGeometry(275,450,50,30);	
   ok_btn->setFont( QFont("helvetica", 10) );
   connect (ok_btn, SIGNAL(clicked()), SLOT(exit_view()) );
   QToolTip::add( ok_btn, "OK, I'm done!" );

   read_file();

}

void ViewWidget::resizeEvent( QResizeEvent * )
{
    view_edit -> setGeometry(10,10, width()-20,height()-50);
    ok_btn -> setGeometry(width()/2-25, height()-35,50,30);
}


void ViewWidget::read_file()
{
	QFile file(loc_file);
	file.open(IO_ReadOnly);
	QTextStream text( &file );
        QString file_contents;
	while (!text.eof() )
		{
		
		  file_contents = text.readLine();
                  view_edit->append(file_contents);
		}
	
	file.close();

}
	
void ViewWidget::exit_view()
{
	delete(this);
}




	
//**************************************************************************
//***[ Remote directory functionality ]*************************************
//**************************************************************************

//---[ Make remote directory widget ]---------------------------------------

RemMkdirWidget::RemMkdirWidget( QWidget *parent, const char *name)
	: QDialog( parent, name, TRUE )
{

   setMinimumSize( 375, 175 );  // keep min. and max. size the same
   setMaximumSize( 375, 175 );

/// Define color for Pushbuttons ///////////////////////////////////////////

   QColor col;
   col = QColor( 26, 78, 151 );
   QColorGroup colgrp;
   colgrp = QColorGroup( yellow, col, col.light(), col.dark(),
            col.dark( 120 ), green, white );

/// MsgLabel ///////////////////////////////////////////////////////////////

   QLabel *msglabel = new QLabel(this);
        msglabel->setText("Enter a remote directory name:");
        msglabel->setFont( QFont("helvetica", 10));
        msglabel->setFrameStyle( QFrame::NoFrame );
        msglabel->setAlignment( AlignBottom | AlignLeft );
        msglabel->setGeometry( 23, 20, 208, 30 );

/// RemMkdirWidget Buttons /////////////////////////////////////////////////

   QPushButton *ok_btn = new QPushButton( "Ok", this, "ok_btn" );
   QPushButton *cancel_btn = new QPushButton( "Cancel", this, "cancel_btn" );

   ok_btn->setGeometry(268, 70, 94, 25 );
   ok_btn->setFont( QFont("helvetica", 10));
   ok_btn->setDefault(TRUE);
   connect( ok_btn, SIGNAL( clicked() ), SLOT( rem_mkdir_ok()) );

   cancel_btn->setGeometry( 268, 105, 94, 25 );
   cancel_btn->setFont( QFont("helvetica", 10));
   connect( cancel_btn, SIGNAL( clicked() ), SLOT( exit_mkdir_rem()) );

/// Make EditBox ///////////////////////////////////////////////////////////

   rem_mkdir_ed = new QLineEdit( this, "rem_mkdir_ed" );
   rem_mkdir_ed->setGeometry( 25, 105, 208, 25);
   rem_mkdir_ed->setFont( QFont( "helvetica", 10));
   rem_mkdir_ed->setFocus();
}

/// RemMkdirWidget Functions ///////////////////////////////////////////////

void RemMkdirWidget::exit_mkdir_rem()
{
 delete(this);
}

void RemMkdirWidget::rem_mkdir_ok()
{
 if (!ftpMkdir( rem_mkdir_ed->text() ))
 {
    QMessageBox::message("Error","Could not create directory!\nDirectory probably already exists\nor you don't have write permissions.");
    return;
 }
 emit refresh_rem();
 delete(this);

}


//---[ View Remote file ]------------------------------------------



RemViewWidget::RemViewWidget( QWidget *parent, const char *name )
    : QDialog( parent, name, TRUE )
{
   view_edit = new QMultiLineEdit( this );
   view_edit->setGeometry (10,10,580,430);
   view_edit->setFont(QFont("helvetica",10));

   ok_btn = new QPushButton("OK", this,"ok_btn");
   ok_btn->setGeometry(275,450,50,30);
   ok_btn->setFont( QFont("helvetica", 10) );
   connect (ok_btn, SIGNAL(clicked()), SLOT(exit_view()) );
   QToolTip::add( ok_btn, "OK, I'm done!" );

   read_file();

}

void RemViewWidget::resizeEvent( QResizeEvent * )
{
    view_edit -> setGeometry(10,10, width()-20,height()-50);
    ok_btn -> setGeometry(width()/2-25, height()-35,50,30);
}



void RemViewWidget::read_file()
{
        QFile file("/tmp/temp_file");
        file.open(IO_ReadOnly);
        QTextStream text( &file );
        QString file_contents;
        while (!text.eof() )
                {

                  file_contents = text.readLine();
                  view_edit->append(file_contents);
                }

        file.close();
        remove("/tmp/temp_file");
}

void RemViewWidget::exit_view()
{
     delete(this);
}






//---[ About ]------------------------------------------------------------

AboutWidget::AboutWidget( QWidget *parent, const char *name)
	: QDialog( parent, name, TRUE )
{

   setMinimumSize( 375, 225 );	// keep min. and max. size the same
   setMaximumSize( 375, 225 );

/// Create message label //////////////////////////////////////////////////

  QLabel *msglabel = new QLabel ( this );
	msglabel->setText("Sprocket FTP-Client version 0.4.3\nCoded by\n\nVincent Bodenstab\nBjorn Tillemans\nMartien Korenblom\n\nFor bug-reports, suggestions, or beer,  mail sprocket@jungfrau.ptf.hro.nl\n");
	msglabel->setFont( QFont("helvetica", 10));
	msglabel->setFrameStyle( QFrame::NoFrame );
	msglabel->setAlignment( AlignTop | WordBreak );
	msglabel->setGeometry( 23, 20, 208, 200 );



/// Create label + movie //////////////////////////////////////////////////

   movielabel = new QLabel( this, "label0");
   movie = QMovie ( MOVIEFILENAME );
   movielabel->setFrameStyle( QFrame::NoFrame );
   movielabel->setGeometry(268, 70, 53, 51 );
   movielabel->setMovie ( movie );
   movielabel->setMargin ( 0 );
   movielabel->setFixedSize ( 53+movielabel->frameWidth()*2, 51+movielabel->frameWidth()*2);

/// The close button for the AboutWidget ///////////////////////////////////

   ok_btn = new QPushButton("OK", this,"ok_btn");
   ok_btn->setGeometry(177,190,50,30);
   ok_btn->setFont( QFont("helvetica", 10) );
   connect (ok_btn, SIGNAL(clicked()), SLOT(exit_about()) );
   QToolTip::add( ok_btn, "OK, I'm done!" );
}


void AboutWidget::exit_about()
{
     delete(this);
}






//**************************************************************************
//***[ Main function ]*****************************************************
//**************************************************************************

int main( int argc, char ** argv )
{
    printf("Starting Sprocket FTP...\n");
    QApplication a( argc, argv );
    FtpWidget m;
    a.setMainWidget( &m );
    m.show();
    return a.exec();
}

//---[ E n d ]------------------------------------------------------------
